#include <Arduino.h>
#include <PIR.cpp>
#include <Transmitter.cpp>
#include <Timer.cpp>
#include <../../Common/LED.cpp>
#include <../../Common/Variables.cpp>

void turnOn();
void turnOff();
void resend();
PIR _pir(13, ON_DURATION, &turnOn, &turnOff);
unsigned int _signalValue;
Transmitter _transmitter;
Timer _timer(1000, &resend);
LED _led(5, FADE_IN_DURATION, FADE_OUT_DURATION);

void sendSignal(int value){
	_signalValue=value;
	Serial.print("Transmitting: ");
	char msg[9];
	sprintf(msg, "LED On: %d", value);
	Serial.println(msg);
	_transmitter.send(msg);
	Serial.println("Transmitted");
}

void turnOn(){
	sendSignal(1);
	_led.on();
}

void turnOff(){
	sendSignal(0);
	_led.off();
}

void resend(){
	sendSignal(_signalValue);
}

void setup() {
	Serial.begin(9600);
	Serial.println("Starting");
	_transmitter.setup();
	_pir.setup();
	Serial.println("Started");
}

void loop() {
	_pir.loop();
	_timer.loop();
	_led.loop();
}